comonad-5.0.5: Comonads

Safe Haskell | Safe
Language | Haskell2010

Data.Functor.Composition

Synopsis

- class Composition o where
  - decompose :: o f g x -> f (g x)
  - compose :: f (g x) -> o f g x

# Documentation

class Composition o where Source #

We often need to distinguish between various forms of Functor-like composition in Haskell in order to please the type system. This lets us work with these representations uniformly.

Methods

decompose :: o f g x -> f (g x) Source #

compose :: f (g x) -> o f g x Source #

Instances

Composition (Compose :: (Type -> Type) -> (Type -> Type) -> Type -> Type) Source # |
Instance details Defined in Data.Functor.Composition Methods decompose :: Compose f g x -> f (g x) Source # compose :: f (g x) -> Compose f g x Source #